unit Alloc;

interface

uses

SysUtils, Windows, AllocTypes;

function Alloc1(Size :Integer; DataSize :Integer) :Pointer;
function WAlloc1(Size :Integer) :TPAWord;
function SmAlloc1(Size :Integer) :TPASmall;
function IAlloc1(Size :Integer) :TPAInteger;
function SAlloc1(Size :Integer) :TPASingle;
function DAlloc1(Size :Integer) :TPADouble;
function EAlloc1(Size :Integer) :TPAExtended;
function CAlloc1(Size :Integer) :TPAChar;
function PointAlloc1(Size :Integer) :TPAPoint;
function PAlloc1(Size :Integer) :TPAPointer;

function Alloc2(row, col :Integer; DataSize :Integer) :Pointer;
function WAlloc2(row, col :Integer) :TPMWord;
function SmAlloc2(row, col :Integer) :TPMSmall;
function IAlloc2(row, col :Integer) :TPMInteger;
function SAlloc2(row, col :Integer) :TPMSingle;
function DAlloc2(row, col :Integer) :TPMDouble;
function EAlloc2(row, col :Integer) :TPMExtended;
function CAlloc2(row, col :Integer) :TPMChar;
function PointAlloc2(row, col :Integer) :TPMPoint;
function PAlloc2(row, col :Integer) :TPMPointer;
function TBAlloc2(row, col :Integer) :TPMThreeBytes;

procedure Free2(p :TPMChar);

type

TQUB_DBuf2_Double             = class
public
  Buf                         :TPMDouble;
  Alt                         :TPMDouble;
  RowCount                    :Integer;
  ColCount                    :Integer;

  constructor Create(NR, NC :Integer);
  destructor Destroy; override;

  procedure Swap;
end;


implementation

//Memory allocation


const


MEM_ALLOC_ERROR = 'Memory allocation error';


function Alloc1(Size :Integer; DataSize :Integer) :Pointer;
begin
  GetMem(Result, Size*DataSize);
  if Result = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
end;

function SmAlloc1(Size :Integer) :TPASmall;
begin
  GetMem(Result, Size*SizeOf(SmallInt));
  if Result = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
end;

function WAlloc1(Size :Integer) :TPAWord;
begin
  GetMem(Result, Size*SizeOf(Word));
  if Result = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
end;

function IAlloc1(Size :Integer) :TPAInteger;
begin
  GetMem(Result, Size*SizeOf(Integer));
  if Result = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
end;

function SAlloc1(Size :Integer) :TPASingle;
begin
  GetMem(Result, Size*SizeOf(Single));
  if Result = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
end;

function DAlloc1(Size :Integer) :TPADouble;
begin
  GetMem(Result, Size*SizeOf(Double));
  if Result = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
end;

function EAlloc1(Size :Integer) :TPAExtended;
begin
  GetMem(Result, Size*SizeOf(Extended));
  if Result = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
end;

function CAlloc1(Size :Integer) :TPAChar;
begin
  GetMem(Result, Size*SizeOf(Char));
  if Result = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
end;

function PointAlloc1(Size :Integer) :TPAPoint;
begin
  GetMem(Result, Size*SizeOf(TPoint));
  if Result = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
end;

function PAlloc1(Size :Integer) :TPAPointer;
begin
  GetMem(Result, Size*SizeOf(Pointer));
  if Result = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
end;

//******************************************************************************

function Alloc2(row, col :Integer; DataSize :Integer) :Pointer;
var
  Buffer :TPMPointer;
  i :Integer;
begin
  raise EOutOfMemory.Create('Don''t use this function ! It is defective - must fix');
  GetMem(Buffer, row*SizeOf(Pointer));
  if Buffer = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
  GetMem(Buffer[0], row*col*DataSize);
  if Buffer[0] = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
  for i := 1 to row - 1 do Buffer[i] := @(Buffer[0][i*col]);
  Result := Buffer;
end;

function SmAlloc2(row, col :Integer) :TPMSmall;
var
  i :Integer;
begin
  GetMem(Result, row*SizeOf(TPASmall));
  if Result = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
  GetMem(Result[0], row*col*SizeOf(SmallInt));
  if Result[0] = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
  for i := 1 to row - 1 do Result[i] := @(Result[0][i*col]);
end;

function WAlloc2(row, col :Integer) :TPMWord;
var
  i :Integer;
begin
  GetMem(Result, row*SizeOf(TPAWord));
  if Result = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
  GetMem(Result[0], row*col*SizeOf(Word));
  if Result[0] = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
  for i := 1 to row - 1 do Result[i] := @(Result[0][i*col]);
end;

function IAlloc2(row, col :Integer) :TPMInteger;
var
  i :Integer;
begin
  GetMem(Result, row*SizeOf(TPAInteger));
  if Result = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
  GetMem(Result[0], row*col*SizeOf(Integer));
  if Result[0] = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
  for i := 1 to row - 1 do Result[i] := @(Result[0][i*col]);
end;

function SAlloc2(row, col :Integer) :TPMSingle;
var
  i :Integer;
begin
  GetMem(Result, row*SizeOf(TPASingle));
  if Result = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
  GetMem(Result[0], row*col*SizeOf(Single));
  if Result[0] = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
  for i := 1 to row - 1 do Result[i] := @(Result[0][i*col]);
end;

function DAlloc2(row, col :Integer) :TPMDouble;
var
  i :Integer;
begin
  GetMem(Result, row*SizeOf(TPADouble));
  if Result = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
  GetMem(Result[0], row*col*SizeOf(Double));
  if Result[0] = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
  for i := 1 to row - 1 do Result[i] := @(Result[0][i*col]);
end;

function EAlloc2(row, col :Integer) :TPMExtended;
var
  i :Integer;
begin
  GetMem(Result, row*SizeOf(TPAExtended));
  if Result = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
  GetMem(Result[0], row*col*SizeOf(Extended));
  if Result[0] = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
  for i := 1 to row - 1 do Result[i] := @(Result[0][i*col]);
end;

function CAlloc2(row, col :Integer) :TPMChar;
var
  i :Integer;
begin
  GetMem(Result, row*SizeOf(TPAChar));
  if Result = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
  GetMem(Result[0], row*col*SizeOf(Char));
  if Result[0] = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
  for i := 1 to row - 1 do Result[i] := @(Result[0][i*col]);
end;

function PointAlloc2(row, col :Integer) :TPMPoint;
var
  i :Integer;
begin
  GetMem(Result, row*SizeOf(TPAPoint));
  if Result = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
  GetMem(Result[0], row*col*SizeOf(TPoint));
  if Result[0] = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
  for i := 1 to row - 1 do Result[i] := @(Result[0][i*col]);
end;

function PAlloc2(row, col :Integer) :TPMPointer;
var
  i :Integer;
begin
  GetMem(Result, row*SizeOf(TPAPointer));
  if Result = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
  GetMem(Result[0], row*col*SizeOf(Pointer));
  if Result[0] = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
  for i := 1 to row - 1 do Result[i] := @(Result[0][i*col]);
end;

function TBAlloc2(row, col :Integer) :TPMThreeBytes;
var
  i :Integer;
begin
  GetMem(Result, row*SizeOf(TPAThreeBytes));
  if Result = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
  GetMem(Result[0], row*col*SizeOf(TThreeBytes));
  if Result[0] = nil then raise EOutOfMemory.Create(MEM_ALLOC_ERROR);
  for i := 1 to row - 1 do Result[i] := @(Result[0][i*col]);
end;


//Memory release

procedure Free2(p :TPMChar);
begin
  if p <> nil then begin
    FreeMem(p[0]);
    FreeMem(p);
  end;
end;


constructor TQUB_DBuf2_Double.Create(NR, NC :Integer);
begin
  RowCount      := NR;
  ColCount      := NC;
  Buf           := DAlloc2(NR, NC);
  Alt           := DAlloc2(NR, NC);
end;

destructor TQUB_DBuf2_Double.Destroy;
begin
  try
    Free2(TPMChar(Buf));
    Free2(TPMChar(Alt));
  finally
    inherited;
  end;
end;

procedure TQUB_DBuf2_Double.Swap;
var
  Tmp       :TPMDouble;
begin
  Tmp       := Buf;
  Buf       := Alt;
  Alt       := Tmp;
end;


//******************************************************************************
end.
